<?php
/*##################################################
 *
 *   $Id: admin_podcast_cats.php 420 2012-03-10 11:26:10Z alain_dev $
 *
 *   begin               	: January 15, 2012
 *   copyright        	    : (C) 2012 Alain GANDON
 *   email               	: alain091@gmail.com
 *
 *   fork from podcast module
 *
###################################################
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
###################################################*/

defined('PATH_TO_ROOT') OR define('PATH_TO_ROOT','..');

require_once(PATH_TO_ROOT.'/admin/admin_begin.php');
define('TITLE', $LANG['administration']);
require_once(PATH_TO_ROOT.'/admin/admin_header.php');
require_once('podcast_begin.php');
require_once('podcast_xml.class.php');

global $podcast_cats;

$Template->set_filenames(array('admin_podcast_cat'=> 'podcast/admin_podcast_cats.tpl'));

$id_up = retrieve(GET, 'id_up', 0, TINTEGER);
$id_down = retrieve(GET, 'id_down', 0, TINTEGER);
$id_show = retrieve(GET, 'show', 0, TINTEGER);
$id_hide = retrieve(GET, 'hide', 0, TINTEGER);
$cat_to_del = retrieve(GET, 'del', 0, TINTEGER);
$cat_to_del_post = retrieve(POST, 'cat_to_del', 0, TINTEGER);
$id_edit = retrieve(GET, 'edit', 0, TINTEGER);
$new_cat = retrieve(GET, 'new', false);
$error = retrieve(GET, 'error', '', TSTRING_UNCHANGE);

if ($id_up > 0)
{
	$podcast_cats->move($id_up, MOVE_CATEGORY_UP);
	redirect(url(basename(__FILE__)));
}
elseif ($id_down > 0)
{
	$podcast_cats->move($id_down, MOVE_CATEGORY_DOWN);
	redirect(url(basename(__FILE__)));
}
elseif ($id_show > 0)
{
	$podcast_cats->change_visibility($id_show, CAT_VISIBLE, LOAD_CACHE);
	redirect(url(basename(__FILE__)));
}
elseif ($id_hide > 0)
{
	$podcast_cats->change_visibility($id_hide, CAT_UNVISIBLE, LOAD_CACHE);
	redirect(url(basename(__FILE__)));
}
elseif ($cat_to_del > 0)
{
	global $PODCAST_CATS;
	$name = empty($PODCAST_CATS[$cat_to_del]['name']) ? 'pas de nom' : $PODCAST_CATS[$cat_to_del]['name'];

	$Template->assign_vars(array(
		'L_REMOVING_CATEGORY' => $PODCAST_LANG['removing_category'],
		'L_EXPLAIN_REMOVING' => $PODCAST_LANG['removing_category_explain'],
		'L_DELETE_CATEGORY_AND_CONTENT' => $PODCAST_LANG['remove_category_and_its_content'],
		'L_MOVE_CONTENT' => $PODCAST_LANG['move_category_content'],
		'L_SUBMIT' => $LANG['delete'],
		'C_DELETE' => true,
		'CATEGORY_TREE' => $podcast_cats->build_select_form(0, 'id_parent', 'id_parent', $cat_to_del),
		'IDCAT' => $cat_to_del,
		'NAMECAT' => htmlentities($name),
	));
}
elseif (!empty($_POST['submit_delete']))
{
	if (empty($cat_to_del_post))
    {
        $Errorh->handler($PODCAST_LANG['unexisting_category'], E_USER_WARNING);
        redirect(url(basename(__FILE__)));
    }
    else
	{
		$delete_full = (!empty($_POST['action']) AND $_POST['action'] == 'delete');
		$id_parent = retrieve(POST, 'id_parent', 0, TINTEGER);

		if ($delete_full)
		{
			$podcast_cats->delete_category_recursively($cat_to_del_post);
		}
		else
		{
			$podcast_cats->delete_category_and_move_content($cat_to_del_post, $id_parent);
		}
	}
	redirect(url(HOST . SCRIPT . '?error=e_success#errorh'), '', '&');
}
elseif (!empty($_POST['submit']))
{
    $ok = false;
    $error_msg = '';

    $id_cat = retrieve(POST, 'idcat', 0, TINTEGER);
    $id_parent = retrieve(POST, 'id_parent', 0, TINTEGER);
    $name = retrieve(POST, 'name', '', TSTRING_UNCHANGE);
    $image = retrieve(POST, 'image', '', TSTRING_UNCHANGE);
    $description = retrieve(POST, 'desc', '', TSTRING_UNCHANGE);
    $itunes_subtitle = retrieve(POST, 'itunes_subtitle', '', TSTRING_UNCHANGE);
    $itunes_categories = retrieve(POST, 'itunes_categories', '', TSTRING_UNCHANGE);

    $specific_mime_type = retrieve(POST, 'specific_mime_type', 0, TINTEGER);
	if (!empty($specific_mime_type))
		$mime_type = retrieve(POST, 'mime_type', 0, TINTEGER);
	else
		$mime_type = -1;

    $specific_active = retrieve(POST, 'specific_active', 0, TINTEGER);
	if (!empty($specific_active))
	{
		$active_post = retrieve(POST, 'active', 0, TARRAY);
		$active = is_array($active_post) ? array_sum($active_post) : 0;
	}
	else
		$active = -1;

    $array_auth_all = Authorizations::build_auth_array_from_form(PODCAST_AUTH_READ, PODCAST_AUTH_CONTRIBUTION, PODCAST_AUTH_WRITE);
    $new_auth = serialize($array_auth_all);

    if (empty($name))
    {
        redirect(url(HOST . SCRIPT . '?error=e_required_fields_empty#errorh'), '', '&');
    }

    if ($id_cat > 0)
    {
        list($ok,$error_msg) = $podcast_cats->update($id_cat, $id_parent, $name, $description, $image, $new_auth,
			$mime_type, $active, $itunes_subtitle, $itunes_categories);
    }
    else
    {
        list($ok,$error_msg) = $podcast_cats->add($id_parent, $name, $description, $image, $new_auth, $mime_type,
			$active, $itunes_subtitle, $itunes_categories);
        if ($ok)
            $id_cat = $podcast_cats->insert_id();
    }

    if ($ok)
    {
        $Cache->generate_module_file('podcast');
		$Cache->load('podcast',true); // force refreshing the cache global variables

        $xml = new PodcastXml();
        $xml->render($id_cat);
    }

	redirect(url(HOST . SCRIPT . '?error=' . $error_msg  . '#errorh'), '', '&');
}
elseif ($new_cat XOR $id_edit > 0)
{
	$cache_base =& $PODCAST_CATS[0];

    $config_auth = !empty($cache_base['auth']) ? $cache_base['auth'] : array();

	if (!empty($id_edit) AND !empty($PODCAST_CATS[$id_edit]))
	{
		$cache_cat =& $PODCAST_CATS[$id_edit];

		$auth = !empty($cache_cat['auth']) ? $cache_cat['auth'] : $config_auth;
        $mime_type = $cache_cat['mime_type'];
        $active = $cache_cat['active'];
        $name = $cache_cat['name'];
        $desc = unparse($cache_cat['desc']);
        $image = $cache_cat['image'];
        $cat_tree = $podcast_cats->build_select_form($cache_cat['id_parent'], 'id_parent', 'id_parent', $id_edit);
        $idcat = $id_edit;
        $itunes_subtitle = $cache_cat['itunes_subtitle'];
        $itunes_categories = $cache_cat['itunes_categories'];
    }
    else
    {
		$auth = $config_auth;
        $mime_type = -1;
        $active = -1;
        $name = '';
        $desc = '';
        $image = '';
        $cat_tree = $podcast_cats->build_select_form(0, 'id_parent', 'id_parent');
        $idcat = 0;
        $itunes_subtitle = '';
        $itunes_categories = '';
    }

    $Template->assign_vars(array(
		'C_EDIT' => true,
		'KERNEL_EDITOR' => display_editor(),
		'L_CATEGORY' => $PODCAST_LANG['category'],
		'L_CONFIG_DISPLAY' => $PODCAST_LANG['config_display'],
		'L_REQUIRED_FIELDS' => $PODCAST_LANG['required_fields'],
		'L_CAT_NAME' => $PODCAST_LANG['cat_name'],
		'L_CAT_LOCATION' => $PODCAST_LANG['cat_location'],
		'L_CAT_DESCRIPTION' => $PODCAST_LANG['cat_description'],
		'L_CAT_IMAGE' => $PODCAST_LANG['cat_image'],
		'L_PREVIEW' => $LANG['preview'],
		'L_RESET' => $LANG['reset'],
		'L_SUBMIT' => ($id_edit > 0) ? $LANG['edit'] : $LANG['add'],
		'L_REQUIRE_TITLE' => $LANG['require_title'],
		'L_MIME_TYPE' => $PODCAST_LANG['mime_type'],
		'L_TYPE_BOTH' => $PODCAST_LANG['type_both'],
		'L_TYPE_MUSIC' => $PODCAST_LANG['type_music'],
		'L_TYPE_VIDEO' => $PODCAST_LANG['type_video'],
		'L_SPECIAL_AUTH' => $PODCAST_LANG['special_auth'],
		'L_READ_AUTH' => $PODCAST_LANG['auth_read'],
		'L_CONTRIBUTE_AUTH' => $PODCAST_LANG['auth_contrib'],
		'L_WRITE_AUTH' => $PODCAST_LANG['auth_write'],
        'L_ITUNES_CAT_LEGEND' => $PODCAST_LANG['itunes_cat_legend'],
        'L_ITUNES_SUBTITLE' => $PODCAST_LANG['itunes_cat_subtitle'],
        'L_ITUNES_CATEGORIES' => $PODCAST_LANG['itunes_cat_categories'],
        'L_ITUNES_CATEGORIES_COM' => $PODCAST_LANG['itunes_cat_categories_com'],
		'L_INVALID_XML_ENTITIES' => $PODCAST_LANG['invalid_xml_entities'],

        'NAME' => $name,
        'DESCRIPTION' => $desc,
        'IMAGE' => $image,
        'CATEGORIES_TREE' => $cat_tree,
        'IDCAT' => $idcat,
		'L_SPECIFIC_MIME_TYPE' => $PODCAST_LANG['specific_mime_type'],
		'SPECIFIC_MIME_TYPE' => ($mime_type<0) ? 'none' : 'block',
		'SPECIFIC_MIME_TYPE_CHECK' => ($mime_type<0) ? '' : 'checked="checked"',
        'TYPE_BOTH' => $podcast_cats->check_value($mime_type,PODCAST_TYPE_BOTH),
        'TYPE_MUSIC' => $podcast_cats->check_value($mime_type,PODCAST_TYPE_MUSIC),
        'TYPE_VIDEO' => $podcast_cats->check_value($mime_type,PODCAST_TYPE_VIDEO),
        'READ_AUTH' => Authorizations::generate_select(PODCAST_AUTH_READ, $auth),
        'CONTRIBUTE_AUTH' => Authorizations::generate_select(PODCAST_AUTH_CONTRIBUTION, $auth),
        'WRITE_AUTH' => Authorizations::generate_select(PODCAST_AUTH_WRITE, $auth),
        'ITUNES_SUBTITLE' => $itunes_subtitle,
        'ITUNES_CATEGORIES' => $itunes_categories,
		'L_SPECIFIC_PARAMETERS' => $PODCAST_LANG['specific_parameters'],
		'L_SPECIFIC_ACTIVE' => $PODCAST_LANG['specific_active'],
		'SPECIFIC_ACTIVE' => ($active<0) ? 'none' : 'block',
		'SPECIFIC_ACTIVE_CHECK' => ($active<0) ? '' : 'checked="checked"',
		'L_DISPLAY_COM' => $PODCAST_LANG['display_com'],
		'COM_CHECK' => $podcast_cats->check_bit($active, PODCAST_COM),
		'COM_VALUE' => PODCAST_COM,
		'L_DISPLAY_NOTE' => $PODCAST_LANG['display_note'],
		'NOTE_CHECK' => $podcast_cats->check_bit($active, PODCAST_NOTE),
		'NOTE_VALUE' => PODCAST_NOTE,
		'L_DISPLAY_USER' => $PODCAST_LANG['display_user'],
		'USER_CHECK' => $podcast_cats->check_bit($active, PODCAST_USER),
		'USER_VALUE' => PODCAST_USER,
		'L_DISPLAY_COUNT' => $PODCAST_LANG['display_count'],
		'COUNT_CHECK' => $podcast_cats->check_bit($active, PODCAST_COUNT),
		'COUNT_VALUE' => PODCAST_COUNT,
		'L_DISPLAY_DATE' => $PODCAST_LANG['display_date'],
		'DATE_CHECK' => $podcast_cats->check_bit($active, PODCAST_DATE),
		'DATE_VALUE' => PODCAST_DATE,
		'L_DISPLAY_DESC' => $PODCAST_LANG['display_desc'],
		'DESC_CHECK' => $podcast_cats->check_bit($active, PODCAST_DESC),
		'DESC_VALUE' => PODCAST_DESC,
		'L_DISPLAY_NBR' => $PODCAST_LANG['display_nbr'],
		'NBR_CHECK' => $podcast_cats->check_bit($active, PODCAST_NBR),
		'NBR_VALUE' => PODCAST_NBR,
    ));
}
else
{
	if (!empty($error))
	{
		switch ($error)
		{
			case 'e_required_fields_empty':
				$Errorh->handler($PODCAST_LANG['required_fields_empty'], E_USER_WARNING);
				break;
			case 'e_unexisting_category':
				$Errorh->handler($PODCAST_LANG['unexisting_category'], E_USER_WARNING);
				break;
			case 'e_new_cat_does_not_exist':
				$Errorh->handler($PODCAST_LANG['new_cat_does_not_exist'], E_USER_WARNING);
				break;
				case 'e_infinite_loop':
				$Errorh->handler($PODCAST_LANG['infinite_loop'], E_USER_WARNING);
				break;
			case 'e_success':
				$Errorh->handler($PODCAST_LANG['successful_operation'], E_USER_SUCCESS);
				break;
		}
	}

	$podcast_cats->set_display_config($podcast_httprequest_cat_config);

	$Template->assign_block_vars('categories_management', array(
        'CATEGORIES' => $podcast_cats->build_administration_interface()
        ));
	$Template->assign_vars(array(
		'L_MANAGEMENT_CATS' => $PODCAST_LANG['management_cat'],
		'THEME' => $CONFIG['theme']
        ));
}

require_once('admin_podcast_menu.php');

$Template->pparse('admin_podcast_cat');

require_once(PATH_TO_ROOT.'/admin/admin_footer.php');

?>
