<?php
/*##################################################
 *
 *   $Id: admin_podcast_config.php 420 2012-03-10 11:26:10Z alain_dev $
 *
 *   begin               	: January 15, 2012
 *   copyright        	    : (C) 2012 Alain GANDON
 *   email               	: alain091@gmail.com
 *
 *   fork from podcast module
 *
###################################################
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
###################################################*/

defined('PATH_TO_ROOT') OR define('PATH_TO_ROOT','..');

require_once(PATH_TO_ROOT.'/admin/admin_begin.php');
define('TITLE', $LANG['administration']);
require_once(PATH_TO_ROOT.'/admin/admin_header.php');
require_once('podcast_begin.php');

if (!empty($_POST['valid']))
{
	$Session->csrf_post_protect();

	$display_array = retrieve(POST, 'active', 0, TARRAY);
	$active = is_array($display_array) ? array_sum($display_array) : 0;
	
	$cache_base =& $PODCAST_CATS[0];

	// Gnre le tableau de configuration.
	$config_podcast = array (
		'pagin' => max(1, retrieve(POST, 'pagin', $PODCAST_CONFIG['pagin'], TINTEGER)),
		'nbr_column' => max(1, retrieve(POST, 'nbr_column', $PODCAST_CONFIG['nbr_column'], TINTEGER)),
		'note_max' => max(1, retrieve(POST, 'note_max', $PODCAST_CONFIG['note_max'], TINTEGER)),
		'width' => max(1, retrieve(POST, 'width', $PODCAST_CONFIG['width'], TINTEGER)),
		'height' => max(1, retrieve(POST, 'height', $PODCAST_CONFIG['height'], TINTEGER)),
		'root' => array(
			'id_parent' => -1,
			'order' => 1,
			'name' => retrieve(POST, 'name', $cache_base['name'], TSTRING_UNCHANGE),
			'desc' => retrieve(POST, 'desc', $cache_base['desc'], TSTRING_UNCHANGE),
			'visible' => true,
			'image' => 'podcast.png',
			'num_podcast' => isset($cache_base['num_podcast']) ? intval($cache_base['num_podcast']) : 0,
			'mime_type' => retrieve(POST, 'mime_type', $cache_base['mime_type'], TINTEGER),
			'active' => $active,
			'itunes_copyright' => retrieve(POST, 'itunes_copyright', $cache_base['itunes_copyright'], TSTRING_UNCHANGE),
			'itunes_author' => retrieve(POST, 'itunes_author', $cache_base['itunes_author'], TSTRING_UNCHANGE),
			'itunes_email' => retrieve(POST, 'itunes_email', $cache_base['itunes_email'], TSTRING_UNCHANGE),
			'auth' => Authorizations::build_auth_array_from_form(PODCAST_AUTH_READ, PODCAST_AUTH_CONTRIBUTION, PODCAST_AUTH_WRITE),
		)
	);

	// Met  jour les notes des fichiers.
	if (!empty($PODCAST_CONFIG['note_max']) AND $PODCAST_CONFIG['note_max'] != $config_podcast['note_max'])
	{
		$Sql->query_inject("UPDATE ".PREFIX."podcast
            SET note = note * " . floor($config_podcast['note_max']/$PODCAST_CONFIG['note_max']), __LINE__, __FILE__);
	}

	$Sql->query_inject("UPDATE ".PREFIX."configs
        SET value = '" . $Sql->escape(serialize($config_podcast)) . "'
        WHERE name = 'podcast'", __LINE__, __FILE__);

	$Cache->generate_module_file('podcast');
	$Cache->load('podcast',true); // force refreshing the cache global variables
	
	require_once('podcast_xml.class.php');
	$query = "SELECT id
		FROM " . PREFIX . "podcast_cat";
	$result = $Sql->query_while($query, __FILE__, __LINE__);
	while ($row = $Sql->fetch_assoc($result))
	{
		$xml = new PodcastXml();
		$xml->render($row['id']);
		unset($xml);
	}

	redirect(HOST . SCRIPT);
}
else
{
	$Template->set_filenames(array('admin_podcast_config'=> 'podcast/admin_podcast_config.tpl'));
	
	$cache_base =& $PODCAST_CATS[0];

    $name = empty($cache_base['name']) ? '' : $cache_base['name'];    
    $mime_type = !isset($cache_base['mime_type']) ? -1 : $cache_base['mime_type'];
    $active = empty($cache_base['active']) ? 0 : $cache_base['active'];
    $auth = empty($cache_base['auth']) ? array() : $cache_base['auth'];
    
    $itunes_copyright = empty($cache_base['itunes_copyright']) ? '' : $cache_base['itunes_copyright']; 
    $itunes_author = empty($cache_base['itunes_author']) ? '' : $cache_base['itunes_author']; 
    $itunes_email = empty($cache_base['itunes_email']) ? '' : $cache_base['itunes_email']; 
    
	$Template->assign_vars(array(
		'L_CONFIG_GENERAL' => $PODCAST_LANG['config_general'],
		'L_MODULE_NAME' => $PODCAST_LANG['module_name'],
		'L_MODULE_NAME_EXPLAIN' => $PODCAST_LANG['module_name_explain'],
		'MODULE_NAME' => $name,
		'L_MODULE_DESC' => $PODCAST_LANG['module_desc'],
		'KERNEL_EDITOR' => display_editor(),
		'CONTENTS' => unparse($cache_base['desc']),
		'L_CONFIG_DISPLAY' => $PODCAST_LANG['config_display'],
		'L_NBR_COLS' => $PODCAST_LANG['nbr_cols'],
		'NBR_COLS' => $PODCAST_CONFIG['nbr_column'],
		'L_PAGINATION' => $PODCAST_LANG['pagination'],
		'PAGINATION' => $PODCAST_CONFIG['pagin'],
		'L_NOTE_MAX' => $PODCAST_LANG['note'],
		'NOTE_MAX' => $PODCAST_CONFIG['note_max'],
		'L_WIDTH_MAX' => $LANG['width_max'],
		'WIDTH_MAX' => $PODCAST_CONFIG['width'],
		'L_HEIGHT_MAX' => $LANG['height_max'],
		'HEIGHT_MAX' => $PODCAST_CONFIG['height'],

		'L_DISPLAY_COM' => $PODCAST_LANG['display_com'],
		'COM_CHECK' => $podcast_cats->check_bit($cache_base['active'], PODCAST_COM),
		'COM_VALUE' => PODCAST_COM,
		'L_DISPLAY_NOTE' => $PODCAST_LANG['display_note'],
		'NOTE_CHECK' => $podcast_cats->check_bit($cache_base['active'], PODCAST_NOTE),
		'NOTE_VALUE' => PODCAST_NOTE,
		'L_DISPLAY_USER' => $PODCAST_LANG['display_user'],
		'USER_CHECK' => $podcast_cats->check_bit($cache_base['active'], PODCAST_USER),
		'USER_VALUE' => PODCAST_USER,
		'L_DISPLAY_COUNT' => $PODCAST_LANG['display_count'],
		'COUNT_CHECK' => $podcast_cats->check_bit($cache_base['active'], PODCAST_COUNT),
		'COUNT_VALUE' => PODCAST_COUNT,
		'L_DISPLAY_DATE' => $PODCAST_LANG['display_date'],
		'DATE_CHECK' => $podcast_cats->check_bit($cache_base['active'], PODCAST_DATE),
		'DATE_VALUE' => PODCAST_DATE,
		'L_DISPLAY_DESC' => $PODCAST_LANG['display_desc'],
		'DESC_CHECK' => $podcast_cats->check_bit($cache_base['active'], PODCAST_DESC),
		'DESC_VALUE' => PODCAST_DESC,
		'L_DISPLAY_NBR' => $PODCAST_LANG['display_nbr'],
		'NBR_CHECK' => $podcast_cats->check_bit($cache_base['active'], PODCAST_NBR),
		'NBR_VALUE' => PODCAST_NBR,
		
		'L_MIME_TYPE' => $PODCAST_LANG['mime_type'],
		'L_TYPE_BOTH' => $PODCAST_LANG['type_both'],
		'TYPE_BOTH' => $podcast_cats->check_value($mime_type,PODCAST_TYPE_BOTH),
		'L_TYPE_MUSIC' => $PODCAST_LANG['type_music'],
		'TYPE_MUSIC' => $podcast_cats->check_value($mime_type,PODCAST_TYPE_MUSIC),
		'L_TYPE_VIDEO' => $PODCAST_LANG['type_video'],
		'TYPE_VIDEO' => $podcast_cats->check_value($mime_type,PODCAST_TYPE_VIDEO),
		'L_CONFIG_AUTH' => $PODCAST_LANG['config_auth'],
		'L_CONFIG_AUTH_EXPLAIN' => $PODCAST_LANG['config_auth_explain'],
		'L_AUTH_READ' => $PODCAST_LANG['auth_read'],
		'AUTH_READ' => Authorizations::generate_select(PODCAST_AUTH_READ, $auth),
		'L_AUTH_CONTRIBUTE' => $PODCAST_LANG['auth_contrib'],
		'AUTH_CONTRIBUTE' => Authorizations::generate_select(PODCAST_AUTH_CONTRIBUTION, $auth),
		'L_AUTH_WRITE' => $PODCAST_LANG['auth_write'],
		'AUTH_WRITE' => Authorizations::generate_select(PODCAST_AUTH_WRITE, $auth),
		'L_REQUIRE' => $PODCAST_LANG['require'],
		'L_UPDATE' => $LANG['update'],
		'L_PREVIEW' => $LANG['preview'],
		'L_RESET' => $LANG['reset'],
        'L_ITUNES_LEGEND' => $PODCAST_LANG['itunes_legend'],
        'L_ITUNES_COPYRIGHT' => $PODCAST_LANG['itunes_copyright'],
        'L_ITUNES_AUTHOR' => $PODCAST_LANG['itunes_author'],
        'L_ITUNES_EMAIL' => $PODCAST_LANG['itunes_email'],
        'ITUNES_COPYRIGHT' => $itunes_copyright,
        'ITUNES_AUTHOR' => $itunes_author,
        'ITUNES_EMAIL' => $itunes_email,
		'L_INVALID_XML_ENTITIES' => $PODCAST_LANG['invalid_xml_entities']
	));

	require_once('admin_podcast_menu.php');
	
	$Template->pparse('admin_podcast_config');
}

require_once(PATH_TO_ROOT.'/admin/admin_footer.php');

?>