<?php
/*##################################################
 *
 *   $Id: moderation_podcast.php 428 2012-03-19 19:35:04Z alain_dev $
 *
 *   begin               	: January 15, 2012
 *   copyright        	    : (C) 2012 Alain GANDON
 *   email               	: alain091@gmail.com
 *
 *   fork from podcast module
 *
###################################################
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
###################################################*/

defined('PATH_TO_ROOT') OR define('PATH_TO_ROOT','..');

require_once(PATH_TO_ROOT.'/kernel/begin.php');

if (!$User->check_level(MODO_LEVEL))
{
	$Errorh->handler('e_auth', E_USER_REDIRECT);
	exit;
}

require_once('podcast_begin.php');

global $podcast_cats;

$Template->set_filenames(array('podcast_moderation' => 'podcast/moderation_podcast.tpl'));

$Bread_crumb->add($PODCAST_CATS[0]['name'], url('podcast.php'));
$Bread_crumb->add($LANG['modo_panel'], url('moderation_podcast.php'));

define('TITLE', $LANG['modo_panel']);
require_once(PATH_TO_ROOT.'/kernel/header.php');

if (!empty($_POST['submit']))
{
	$Session->csrf_post_protect();

	$action = retrieve(POST, 'action', array(), TARRAY);
	$show = $hide = $unaprobed = $delete = array();
	$items = array();

	if (!empty($action))
	{
		foreach ($action as $key => $value)
		{	
			if ($value == 'visible')
			{
				$show[] = $key;
			}
			elseif ($value == 'unvisible')
			{
				$hide[] = $key;
			}
			elseif ($value == 'unaprobed')
			{
				$unaprobed[] = $key;
			}
			elseif ($value == 'delete')
			{
				$delete[] = $key;
			}
			$items[$key] = 1;
		}
		
		if (!empty($show))
		{
			$list_in = implode(',',$show);
			$Sql->query_inject("UPDATE " . PREFIX . "podcast
				SET infos = " . PODCAST_STATUS_APROBED . "
				WHERE id IN (" . $list_in . ")", __LINE__, __FILE__);
		}
		
		if (!empty($hide))
		{
			$list_in = implode(',',$hide);
			$Sql->query_inject("UPDATE " . PREFIX . "podcast
				SET infos = " . PODCAST_STATUS_UNVISIBLE . "
				WHERE id IN (" . $list_in .")", __LINE__, __FILE__);
		}
		
		if (!empty($unaprobed))
		{
			$list_in = implode(',',$unaprobed);
			$Sql->query_inject("UPDATE " . PREFIX . "podcast
				SET infos = " . PODCAST_STATUS_UNAPROBED . "
				WHERE id IN (" . $list_in .")", __LINE__, __FILE__);
		}

		if (!empty($delete))
		{
			$list_in = implode(',',$delete);
			$Sql->query_inject("DELETE FROM " . PREFIX . "podcast
				WHERE id IN (" . $list_in .")", __LINE__, __FILE__);
			$Sql->query_inject("DELETE FROM " . PREFIX . "com
				WHERE (idprov IN (" . $list_in . "))
				AND script = 'podcast'", __LINE__, __FILE__);
		}

		// Feeds Regeneration
		import('content/syndication/feed');
		Feed::clear_cache('podcast');
		$podcast_cats->recount_podcast_per_cat();

		require_once('podcast_xml.class.php');
		$ids = array_keys($items);		
		$query = "SELECT DISTINCT idcat
			FROM " . PREFIX . "podcast
			WHERE id IN (" . implode(',',$ids).")";
        $result = $Sql->query_while($query, __FILE__, __LINE__);
		while ($row = $Sql->fetch_assoc($result))
		{
			$xml = new PodcastXml();
			$xml->render($row['idcat']);
			unset($xml);
		}

		redirect_confirm(url('moderation_podcast.php'), $PODCAST_LANG['moderation_success'], TIME_REDIRECT);
		exit;
	}
	else
	{
		redirect(url('moderation_podcast.php'));
	}
}
elseif (!empty($_GET['recount']))
{
	// Feeds Regeneration
	import('content/syndication/feed');
	Feed::clear_cache('podcast');
	$podcast_cats->recount_podcast_per_cat();
	
	redirect_confirm(url('moderation_podcast.php'), $PODCAST_LANG['recount_success'], TIME_REDIRECT);	
}
else
{
	// Filtre pour le panneau de modration.
	$array_cats = $js_array = array();

	if (!empty($_POST['filter']))
	{
		$state = retrieve(POST, 'state', 'all', TSTRING_UNCHANGE);
		$cat = retrieve(POST, 'idcat', 0, TINTEGER);
		$sub_cats = retrieve(POST, 'sub_cats', false, TBOOL);
		
		if ($state == 'visible')
		{
			$db_where = PODCAST_STATUS_APROBED;
		}
		elseif ($state == 'unvisible')
		{
			$db_where = PODCAST_STATUS_UNVISIBLE;
		}
		elseif ($state == 'unaprobed')
		{
			$db_where = PODCAST_STATUS_UNAPROBED;
		}
		else
		{
			$db_where = null;
		}
		
		if ($sub_cats)
		{
			$podcast_cats->build_children_id_list($cat, $array_cats, RECURSIVE_EXPLORATION, ADD_THIS_CATEGORY_IN_LIST, PODCAST_AUTH_READ);
		}
	}
	else
	{
		$cat = 0;
		$db_where = $sub_cats = null;
		$podcast_cats->build_children_id_list(0, $array_cats, RECURSIVE_EXPLORATION, ADD_THIS_CATEGORY_IN_LIST, PODCAST_AUTH_READ);
	}
	
	//On cre une pagination si le nombre de fichier est trop important.
	import('util/pagination');
	$Pagination = new Pagination();

	$nbr_podcast = 0;
	$result = $Sql->query_while("SELECT * FROM " . PREFIX . "podcast WHERE " . (!empty($array_cats) ? 'idcat IN (' . "'" . implode("', '", $array_cats) . "'" . ')' : 'idcat=' . (!empty($cat) ? $cat : 0)) . (is_null($db_where) ? '' : ' AND infos=' . $db_where) . " ORDER BY infos ASC, timestamp DESC" . $Sql->limit($Pagination->get_first_msg(NUM_MODO_PODCAST, 'p'), NUM_MODO_PODCAST), __LINE__, __FILE__);

	while ($row = $Sql->fetch_assoc($result))
	{
		$nbr_podcast++;
		$js_array[] = $row['id'];

		$Template->assign_block_vars('files', array(
			'ID' => $row['id'],
			'NAME' => $row['name'],
			'U_FILE' => $podcast_cats->get_item_link($row['id'],$row['idcat'],$row['name']),
			'U_EDIT' => $podcast_cats->get_action_link(array('edit'=>$row['id'])),
			'CAT' => !empty($PODCAST_CATS[$row['idcat']]) ? $PODCAST_CATS[$row['idcat']]['name'] : $LANG['unknow'],
			'U_CAT' => $podcast_cats->get_action_link(array('cat'=>$row['idcat']),false,'podcast'),
			'COLOR' => $row['infos'] == PODCAST_STATUS_UNVISIBLE ? '#FFEE99' : ($row['infos'] == PODCAST_STATUS_APROBED ? '#CCFFCC' : '#FFCCCC'),
			'SHOW' => $row['infos'] == PODCAST_STATUS_APROBED ? ' checked="checked"' : '',
			'HIDE' => $row['infos'] == PODCAST_STATUS_UNVISIBLE ? ' checked="checked"' : '',
			'UNAPROBED' => $row['infos'] == PODCAST_STATUS_UNAPROBED ? ' checked="checked"' : '',
		));
	}

	$Sql->query_close($result);

	$Template->assign_vars(array(
		'C_DISPLAY' => 1,
		'L_FILTER' => $PODCAST_LANG['filter'],
		'L_DISPLAY_FILE' => $PODCAST_LANG['display_file'],
		'L_ALL' => $PODCAST_LANG['all_file'],
		'SELECTED_ALL' => empty($db_where) ? ' selected="selected"' : '',
		'L_FVISIBLE' => $PODCAST_LANG['visible'],
		'SELECTED_VISIBLE' => $db_where === PODCAST_STATUS_APROBED ? ' selected="selected"' : '',
		'L_FUNVISIBLE' => $PODCAST_LANG['unvisible'],
		'SELECTED_UNVISIBLE' => $db_where === PODCAST_STATUS_UNVISIBLE ? ' selected="selected"' : '',
		'L_FUNAPROBED' => $PODCAST_LANG['unaprobed'],
		'SELECTED_UNAPROBED' => $db_where === PODCAST_STATUS_UNAPROBED ? ' selected="selected"' : '',
		'L_CATEGORIES' => $PODCAST_LANG['from_cats'],
		'CATEGORIES_TREE' => $podcast_cats->build_select_form($cat, 'idcat', 'idcat', 0, PODCAST_AUTH_READ, $PODCAST_CATS[$cat]['auth']),
		'L_INCLUDE_SUB_CATS' => $PODCAST_LANG['include_sub_cats'],
		'SUB_CATS' => !empty($sub_cats) ? ' checked="checked"' : '',
		'L_MODO_PANEL' => $LANG['modo_panel'],
		'L_NAME' => $LANG['name'],
		'L_CATEGORY' => $LANG['category'],
		'L_VISIBLE' => $PODCAST_LANG['show_podcast_short'],
		'L_UNVISIBLE' => $PODCAST_LANG['hide_podcast_short'],
		'L_UNAPROBED' => $PODCAST_LANG['unaprobed_podcast_short'],
		'L_DELETE' => $LANG['delete'],
		'C_NO_MODERATION' => $nbr_podcast > 0 ? 0 : 1,
		'L_NO_MODERATION' => $PODCAST_LANG['no_podcast_moderate'],
		'L_CONFIRM_DELETE' => str_replace('\'', '\\\'', $PODCAST_LANG['confirm_delete_podcast']),
		'L_CONFIRM_DELETE_ALL' => str_replace('\'', '\\\'', $PODCAST_LANG['confirm_delete_podcast_all']),
		'L_LEGEND' => $PODCAST_LANG['legend'],
		'L_FILE_UNAPROBED' => $PODCAST_LANG['file_unaprobed'],
		'L_FILE_UNVISIBLE' => $PODCAST_LANG['file_unvisible'],
		'L_FILE_VISIBLE' => $PODCAST_LANG['file_visible'],
		'PAGINATION' => $Pagination->display('moderation_podcast.php?p=%d', $nbr_podcast, 'p', NUM_MODO_PODCAST, 3),
		'L_SUBMIT' => $LANG['submit'],
		'L_RESET' => $LANG['reset'],
		'C_ADMIN' => $User->check_level(ADMIN_LEVEL),
		'L_RECOUNT_PODCAST' => $PODCAST_LANG['recount_per_cat'],
		'JS_ARRAY' => '"' . implode('", "', $js_array) . '"'
	));
}

$Template->pparse('podcast_moderation');

require_once(PATH_TO_ROOT.'/kernel/footer.php');

?>