<?php
/*##################################################
 *
 *   $Id: podcast.php 449 2012-04-13 18:35:20Z alain_dev $
 *
 *   begin               	: January 15, 2012
 *   copyright        	    : (C) 2012 Alain GANDON
 *   email               	: alain091@gmail.com
 *
 *   fork from podcast module
 *
###################################################
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
###################################################*/

defined('PATH_TO_ROOT') OR define('PATH_TO_ROOT','..');

require_once(PATH_TO_ROOT.'/kernel/begin.php');
require_once('podcast_begin.php');

$Template->set_filenames(array('podcast' => 'podcast/podcast.tpl'));

$id_podcast = retrieve(GET, 'id', 0, TINTEGER);
$id_cat = retrieve(GET, 'cat', 0, TINTEGER);

$level = array(0 => '', 1 => ' class="modo"', 2 => ' class="admin"');

define('PODCAST_OPTION_SELECTED', ' selected="selected"');

// Display caterories and podcast files.
if (empty($id_podcast) AND ($id_cat >= 0))
{
	//if the category doesn't exist or is not visible
	if (empty($PODCAST_CATS[$id_cat]) ||
        $PODCAST_CATS[$id_cat]['visible'] === false ||
        !$User->check_auth($PODCAST_CATS[$id_cat]['auth'], PODCAST_AUTH_READ))
	{
		$Errorh->handler('e_unexist_cat', E_USER_REDIRECT);
		exit;
	}

	$podcast_cats->bread_crumb($id_cat);

	define('TITLE', $PODCAST_CATS[$id_cat]['name']);

	require_once(PATH_TO_ROOT.'/kernel/header.php');

	$i = 1;
	//List of children categories
	foreach ($PODCAST_CATS as $id => $params)
	{
		if ($id != 0 &&
            $params['visible'] &&
            $params['id_parent'] == $id_cat &&
            $User->check_auth($params['auth'], PODCAST_AUTH_READ))
		{
			if ($i % $PODCAST_CONFIG['nbr_column'] == 1)
			{
				$Template->assign_block_vars('row', array());
			}

			$Template->assign_block_vars('row.list_cats', array(
				'ID' => $id,
				'NAME' => $params['name'],
				'WIDTH' => floor(100 / (float)$PODCAST_CONFIG['nbr_column']),
				'SRC' => !empty($params['image']) ? $params['image'] : 'podcast_mini.png',
				'IMG_NAME' => $params['name'],
				'NUM_PODCAST' => ($params['active'] & PODCAST_NBR) !== 0 ? sprintf(($params['num_podcast'] > 1 ? $PODCAST_LANG['num_podcasts'] : $PODCAST_LANG['num_podcast']), $params['num_podcast']) : '',
				'U_CAT' => $podcast_cats->get_cat_link($id,$params['name']),
				'U_EDIT_CAT' => $podcast_cats->get_action_link(array('edit'=>$id),true,'admin_podcast_cats'),
				'U_XML' => HOST.DIR.'/podcast/xml/'.url_encode_rewrite($params['name']).'.xml?q='.uniqid('podcast',true),
			));

			$i++;
		}
	}

	$c_write = $User->check_auth($PODCAST_CATS[$id_cat]['auth'], PODCAST_AUTH_WRITE);
	$c_contrib = ($User->check_auth($PODCAST_CATS[$id_cat]['auth'], PODCAST_AUTH_CONTRIBUTION) AND !$c_write);
	
	if (empty($id_cat))
		$u_edit_cat = $podcast_cats->get_action_link(array(),false,'admin_podcast_config');
	else
		$u_edit_cat = $podcast_cats->get_action_link(array('edit'=>$id_cat),false,'admin_podcast_cats');
		
	$Template->assign_vars(array(
		'C_CATEGORIES' => true,
		'TITLE' => $PODCAST_CATS[$id_cat]['name'],
		'C_ADMIN' => $User->check_level(ADMIN_LEVEL),
		'C_WRITE' => $c_write,
		'U_EDIT_CAT' => $u_edit_cat,
		'C_ADD_FILE' => $c_write || $c_contrib ,
		'U_ADD_FILE' => $podcast_cats->get_action_link(array('cat'=>$id_cat,'add'=>1)),
		'L_ADD_FILE' => $PODCAST_LANG['add_podcast'],
		'C_DESCRIPTION' => !empty($PODCAST_CATS[$id_cat]['desc']),
		'DESCRIPTION' => second_parse($PODCAST_CATS[$id_cat]['desc']),
		'C_SUB_CATS' => ($i > 1),
		'IDCAT' => $id_cat,
		'C_ISCAT' => ($id_cat>0),
		'U_XML' => HOST.DIR.'/podcast/xml/'.url_encode_rewrite($PODCAST_CATS[$id_cat]['name']).'.xml?q='.uniqid('podcast',true)
	));

	//Contenu de la catgorie
	if ($PODCAST_CATS[$id_cat]['num_podcast'] > 0)
	{
		$get_sort = retrieve(GET, 'sort', '', TSTRING_UNCHANGE);
		$get_mode = retrieve(GET, 'mode', '', TSTRING_UNCHANGE);

		$mode = ($get_mode == 'asc') ? 'asc' : 'desc';
		$unget = (!empty($get_sort) AND !empty($mode)) ? '?sort=' . $get_sort . '&amp;mode=' . strtolower($mode) : '';
		$selected_fields = array('alpha' => '', 'date' => '', 'nbr' => '', 'note' => '', 'com' => '', 'asc' => '', 'desc' => '');

		switch ($get_sort)
		{
			case 'alpha':
				$sort = 'name';
				$selected_fields['alpha'] = PODCAST_OPTION_SELECTED;
				break;
			default:
			case 'date':
				$sort = 'timestamp';
				$selected_fields['date'] = PODCAST_OPTION_SELECTED;
				break;
			case 'nbr':
				$sort = 'counter';
				$selected_fields['nbr'] = PODCAST_OPTION_SELECTED;
				break;
			case 'note':
				$sort = 'nbrnote';
				$selected_fields['note'] = PODCAST_OPTION_SELECTED;
				break;
			case 'com':
				$sort = 'nbr_com';
				$selected_fields['com'] = PODCAST_OPTION_SELECTED;
				break;
		}

		if ($mode == 'asc')
		{
			$selected_fields['asc'] = PODCAST_OPTION_SELECTED;
		}
		else
		{
			$selected_fields['desc'] = PODCAST_OPTION_SELECTED;
		}

		$Template->assign_vars(array(
			'L_ALPHA' => $PODCAST_LANG['sort_title'],
			'L_DATE' => $LANG['date'],
			'L_NBR' => $PODCAST_LANG['sort_popularity'],
			'L_NOTE' => $LANG['note'],
			'L_COM' => $LANG['com'],
			'L_DESC' => $LANG['desc'],
			'L_ASC' => $LANG['asc'],
			'L_ORDER_BY' => $LANG['orderby'],
			'L_CONFIRM_DELETE_FILE' => str_replace('\'', '\\\'', $PODCAST_LANG['confirm_delete_podcast']),
			'SELECTED_ALPHA' => $selected_fields['alpha'],
			'SELECTED_DATE' => $selected_fields['date'],
			'SELECTED_NBR' => $selected_fields['nbr'],
			'SELECTED_NOTE' => $selected_fields['note'],
			'SELECTED_COM' => $selected_fields['com'],
			'SELECTED_ASC' => $selected_fields['asc'],
			'SELECTED_DESC' => $selected_fields['desc'],
		));

		//On cre une pagination si le nombre de fichiers est trop important.
		import('util/pagination');
		$Pagination = new Pagination();

		//Notes
		import('content/note');
		import('content/comments');

		$target = $podcast_cats->get_action_link(array('cat'=>$id_cat),false,'podcast');
		$target .= (strpos($target, '?') !== false) ? '&' : '?';

		$Template->assign_vars(array(
			'PAGINATION' => $Pagination->display($podcast_cats->get_cat_link($id_cat,$PODCAST_CATS[$id_cat]['name'],'p=%d'), $PODCAST_CATS[$id_cat]['num_podcast'], 'p', $PODCAST_CONFIG['pagin'], 3),
			'C_FILES' => true,
			'TARGET_ON_CHANGE_ORDER' => $target,
		));

        $result = $podcast_cats->get_all_cats($id_cat, $sort, $mode, $Pagination);

		while ($row = $Sql->fetch_assoc($result))
		{
			$Template->assign_block_vars('file', array(
				'NAME' => $row['name'],
				'IMG_NAME' => str_replace('"', '\"', $row['name']),
				'C_DESCRIPTION' => !empty($row['contents']),
				'DESCRIPTION' => second_parse($row['contents']),
				'POSTER' => !empty($row['login']) ? sprintf($PODCAST_LANG['podcast_added_by'], $row['login'], PATH_TO_ROOT.'/member/member' . url('.php?id=' . $row['iduser'], '-' . $row['iduser'] . '.php'), $level[$row['level']]) : $LANG['guest'],
				'DATE' => sprintf($PODCAST_LANG['add_on_date'], gmdate_format('date_format_short', $row['timestamp'])),
				'COUNT' => sprintf($PODCAST_LANG['view_n_times'], $row['counter']),
				'NOTE' => $row['nbrnote'] ? Note::display_img($row['note'], $PODCAST_CONFIG['note_max'], $PODCAST_CONFIG['note_max']) : '<em>' . $LANG['no_note'] . '</em>',
				'U_PODCAST_LINK' => $podcast_cats->get_item_link($id,$row['idcat'],$row['name']),
				'U_PODCAST_EDIT' => $podcast_cats->get_action_link(array('cat'=>$row['idcat'],'edit'=>$row['id'])),
				'U_PODCAST_DELETE' => $podcast_cats->get_action_link(array('cat'=>$row['idcat'],'del'=>$row['id'])),
				'U_COM_LINK' => Comments::com_display_link($row['nbr_com'], $podcast_cats->get_item_link($row['id'],$id_cat,$row['name'],'com=0'),$row['id'],'podcast'),
			));
		}

		$Sql->query_close($result);
	}
	else
	{
		$Template->assign_vars(array(
			'L_NO_FILE_THIS_CATEGORY' => $PODCAST_LANG['none_podcast'],
			'C_NO_FILE' => true
		));
	}
}
// Display the podcast file.
elseif ($id_podcast > 0)
{
	$podcast = $podcast_cats->get($id_podcast);
	
	if (empty($podcast) || ($podcast['infos'] & PODCAST_STATUS_UNVISIBLE) !== 0)
	{
		$Errorh->handler('e_unexist_podcast', E_USER_REDIRECT);
		exit;
	}
	
	$id_cat = intval($podcast['idcat']);
	
	$auth = !empty($PODCAST_CATS[$id_cat]['auth'])? $PODCAST_CATS[$id_cat]['auth'] : $PODCAST_CATS[0]['auth'];
	
	if (!$User->check_auth($auth, PODCAST_AUTH_READ))
	{
		$Errorh->handler('e_auth', E_USER_REDIRECT);
		exit;
	}

	$c_write = $User->check_auth($auth, PODCAST_AUTH_WRITE);
	$active = ($PODCAST_CATS[$id_cat]['active']<0) ? $PODCAST_CATS[0]['active'] : $PODCAST_CATS[$id_cat]['active'];
	$mime_type = ($PODCAST_CATS[$id_cat]['mime_type']<0) ? $PODCAST_CATS[0]['mime_type'] : $PODCAST_CATS[$id_cat]['mime_type'];

	$podcast_cats->bread_crumb($podcast['idcat']);
	$Bread_crumb->add($podcast['name'], $podcast_cats->get_item_link($podcast['id'],$podcast['idcat'],$podcast['name']));

	define('TITLE', $podcast['name']);

	require_once(PATH_TO_ROOT.'/kernel/header.php');

	//MAJ du compteur.
	$Sql->query_inject("UPDATE " . LOW_PRIORITY . " " . PREFIX . "podcast
		SET counter = counter + 1
		WHERE id = " . intval($podcast['id']), __LINE__, __FILE__);

	//Affichage notation.
	import('content/note');
	$Note = new Note('podcast', $podcast['id'], $podcast_cats->get_item_link($podcast['id'],$podcast['idcat'],$podcast['name']), $PODCAST_CONFIG['note_max'], '', NOTE_NODISPLAY_NBRNOTES);

	import('content/comments');

	$Template->assign_vars(array(
		'C_DISPLAY_PODCAST' => true,
		'C_WRITE' => $c_write,
		'MODULE_DATA_PATH' => $Template->get_module_data_path('podcast'),
		'ID_PODCAST' => $podcast['id'],
		'NAME' => $podcast['name'],
		'CONTENTS' => second_parse($podcast['contents']),
		'COUNT' => $podcast['counter'],
		'THEME' => $CONFIG['theme'],
		'KERNEL_NOTATION' => $Note->display_form(),
		'HITS' => ((int)$podcast['counter']+1) > 1 ? sprintf($PODCAST_LANG['n_times'], ((int)$podcast['counter']+1)) : sprintf($PODCAST_LANG['n_time'], ((int)$podcast['counter']+1)),
		'NUM_NOTES' => (int)$podcast['nbrnote'] > 1 ? sprintf($PODCAST_LANG['num_notes'], (int)$podcast['nbrnote']) : sprintf($PODCAST_LANG['num_note'], (int)$podcast['nbrnote']),
		'LANG' => $CONFIG['lang'],
		'U_COM' => Comments::com_display_link($podcast['nbr_com'], $podcast_cats->get_item_link($podcast['id'],$id_cat,$podcast['name'],'com=0'), $podcast['id'], 'podcast'),
		'L_DATE' => $LANG['date'],
		'L_SIZE' => $LANG['size'],
		'L_PODCAST_INFOS' => $PODCAST_LANG['podcast_infos'],
		'DATE' => gmdate_format('date_format', $podcast['timestamp']),
		'URL' => $podcast['url'],
		'MIME' => $podcast['mime_type'],
		'WIDTH' => $podcast['width'],
		'HEIGHT' => $podcast['height'],
		'HEIGHT_P' => $podcast['height'] + 50,
		'L_VIEWED' => $LANG['view'],
		'L_BY' => $LANG['by'],
		'BY' => !empty($podcast['login']) ? sprintf($PODCAST_LANG['podcast_added'], $podcast['login'], PATH_TO_ROOT.'/member/member' . url('.php?id=' . $podcast['iduser'], '-' . $podcast['iduser'] . '.php'), $level[$podcast['level']]) : $LANG['guest'],
		'L_CONFIRM_DELETE_PODCAST' => str_replace('\'', '\\\'', $PODCAST_LANG['confirm_delete_podcast']),
		'U_EDIT_PODCAST' => $podcast_cats->get_action_link(array('cat'=>$id_cat,'edit'=>$podcast['id'])),
		'U_DELETE_PODCAST' => $podcast_cats->get_action_link(array('cat'=>$id_cat,'del'=>$podcast['id'])),
		'U_POPUP_PODCAST' => $podcast_cats->get_action_link(array('id'=>$id_cat),false,'podcast_popup'),
		'L_CONFIRM_DELETE_FILE' => str_replace('\'', '\\\'', $PODCAST_LANG['confirm_delete_podcast'])
	));

	$Template->set_filenames(array('podcast_format' => (empty($mime_type_tpl[$mime_type]) ? 'podcast/format/podcast_other.tpl' : 'podcast/' . $mime_type_tpl[$mime_type])));

	//Affichage commentaires.
	if (isset($_GET['com']) AND (($active & PODCAST_COM) !== 0))
	{
		$Template->assign_vars(array(
			'COMMENTS' => display_comments('podcast', $podcast['id'], $podcast_cats->get_item_link($podcast['id'],$podcast['idcat'],$podcast['name'],false,'com=%s')))
			);
	}
}

$Template->pparse('podcast');

require_once(PATH_TO_ROOT.'/kernel/footer.php');

?>