<?php
/*##################################################
 *
 *   $Id: podcast_action.php 448 2012-04-04 19:18:44Z alain_dev $
 *
 *   begin               	: January 15, 2012
 *   copyright        	    : (C) 2012 Alain GANDON
 *   email               	: alain091@gmail.com
 *
 *   fork from podcast module
 *
###################################################
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
###################################################*/

defined('PATH_TO_ROOT') OR define('PATH_TO_ROOT','..');

require_once(PATH_TO_ROOT.'/kernel/begin.php');
require_once('podcast_begin.php');

global $podcast_cats;

$Template->set_filenames(array('podcast_action' => 'podcast/podcast_action.tpl'));

$add = retrieve(GET, 'add', 0, TINTEGER);
$edit = retrieve(GET, 'edit', 0, TINTEGER);
$delete = retrieve(GET, 'del', 0, TINTEGER);
$id_cat = retrieve(GET, 'cat', 0, TINTEGER);

// Suppression d'un fichier.
if ($delete > 0)
{
	$Session->csrf_get_protect();

	$auth = !empty($PODCAST_CATS[$id_cat]['auth'])?$PODCAST_CATS[$id_cat]['auth']:array();

	if (!$User->check_auth($auth, PODCAST_AUTH_WRITE))
	{
		$Errorh->handler('e_auth', E_USER_REDIRECT);
		exit;
	}
	
	$podcast = $podcast_cats->get($delete);
    if (empty($podcast))
    {
		$Errorh->handler('e_unexist_podcast', E_USER_REDIRECT);
		exit;
    }

	$result = $Sql->query_inject("DELETE FROM " . PREFIX . "podcast
        WHERE id = " . intval($delete) . "
        LIMIT 1", __LINE__, __FILE__);

    if ($Sql->affected_rows($result) < 0)
    {
		$Errorh->handler('e_unexist_podcast', E_USER_REDIRECT);
		exit;
    }

	//Deleting comments if the file has
	if ($podcast['nbr_com'] > 0)
	{
		import('content/comments');
		$url = $podcast_cats->get_cat_short_link($delete);
		$url .= (strpos($url,'?') !== false) ? '&amp;' : '?';
		$url .= 'com=%s';
		$Comments = new Comments('podcast', $delete, $url);
		$Comments->delete_all($delete);
	}

	// Feeds Regeneration
	import('content/syndication/feed');
	Feed::clear_cache('podcast');

	$podcast_cats->recount_podcast_per_cat($podcast['idcat']);

	$podcast_cats->bread_crumb($podcast['idcat']);
	$Bread_crumb->add($PODCAST_LANG['delete_podcast'],
		$podcast_cats->get_cat_link($podcast['idcat'],$PODCAST_CATS[$podcast['idcat']]['name']));
		
	// Feeds Regeneration
	import('content/syndication/feed');
	Feed::clear_cache('podcast');

	require_once('podcast_xml.class.php');
	$xml = new PodcastXml();
	$xml->render($podcast['idcat']);
	unset($xml);

	define('TITLE', $PODCAST_LANG['delete_podcast']);
	require_once(PATH_TO_ROOT.'/kernel/header.php');

	redirect_confirm($podcast_cats->get_cat_short_link($podcast['idcat']), $PODCAST_LANG['deleted_success'], TIME_REDIRECT);
}
// Formulaire d'ajout ou d'dition.
elseif (empty($_POST['submit']) AND ($add >= 0 OR $edit > 0))
{
	$Session->csrf_get_protect();

	$auth = !empty($PODCAST_CATS[$id_cat]['auth'])? $PODCAST_CATS[$id_cat]['auth'] : $PODCAST_CATS[0]['auth'];

	$c_write = $User->check_auth($auth, PODCAST_AUTH_WRITE);
	$c_contrib = ($User->check_auth($auth, PODCAST_AUTH_CONTRIBUTION) AND !$c_write);

	if (!$c_write AND !$c_contrib)
	{
		$Errorh->handler('e_auth', E_USER_REDIRECT);
		exit;
	}

	$Template->assign_vars(array(
		'C_ADD_PODCAST' => true,
		'U_TARGET' => url('podcast_action.php'),
		'L_TITLE' => $PODCAST_LANG['podcast_name'],
		'L_CATEGORY' => $PODCAST_LANG['podcast_category'],
		'L_WIDTH' => $PODCAST_LANG['podcast_width'],
		'L_HEIGHT' => $PODCAST_LANG['podcast_height'],
		'L_U_PODCAST' => $PODCAST_LANG['podcast_url'],
		'L_U_PODCAST_EXPLAIN' => $PODCAST_LANG['podcast_url_explain'],
		'L_CONTENTS' => $PODCAST_LANG['podcast_description'],
		'KERNEL_EDITOR' => display_editor(),
		'L_APPROVED' => $PODCAST_LANG['podcast_approved'],
		'L_CONTRIBUTION_LEGEND' => $LANG['contribution'],
		'L_NOTICE_CONTRIBUTION' => $PODCAST_LANG['notice_contribution'],
		'L_CONTRIBUTION_COUNTERPART' => $PODCAST_LANG['contribution_counterpart'],
		'L_CONTRIBUTION_COUNTERPART_EXPLAIN' => $PODCAST_LANG['contribution_counterpart_explain'],
		'L_REQUIRE_NAME' => $PODCAST_LANG['require_name'],
		'L_REQUIRE_URL' => $PODCAST_LANG['require_url'],
		'L_RESET' => $LANG['reset'],
		'L_PREVIEW' => $LANG['preview'],
		'L_SUBMIT' => ($edit > 0) ? $LANG['update'] : $LANG['submit'],
        'L_ITUNES_FILE_LEGEND' => $PODCAST_LANG['itunes_file_legend'],
        'L_ITUNES_FILE_SUBTITLE' => $PODCAST_LANG['itunes_file_subtitle'],
        'L_ITUNES_FILE_DURATION' => $PODCAST_LANG['itunes_file_duration'],
        'L_ITUNES_FILE_KEYWORDS' => $PODCAST_LANG['itunes_file_keywords'],
        'L_ITUNES_FILE_KEYWORDS_COM' => $PODCAST_LANG['itunes_file_keywords_com'],
	));

	// Construction du tableau des catgories musicales.
	$js_id_music = array();
	foreach ($PODCAST_CATS as $key => $value)
	{
		if ($value['mime_type'] == PODCAST_TYPE_MUSIC)
		{
			$js_id_music[] = $key;
		}
	}

	// dition.
	if ($edit > 0)
    {
        $podcast = $Sql->query_array(PREFIX . 'podcast', '*', "WHERE id = " . intval($edit), __LINE__, __FILE__);

        if (empty($podcast))
        {
            $Errorh->handler('e_unexist_podcast', E_USER_REDIRECT);
            exit;
        }
		
		$podcast_cats->bread_crumb($podcast['idcat']);

		if (in_array($podcast['mime_type'], $mime_type['audio']))
		{
			$podcast_type = PODCAST_TYPE_MUSIC;
		}
		else
		{
			$podcast_type = PODCAST_TYPE_VIDEO;
		}

		$approved = $podcast_cats->check_bit($podcast['infos'], PODCAST_STATUS_APROBED);
		$cat_mime_type = ($PODCAST_CATS[$id_cat]['mime_type']<0) ? $PODCAST_CATS[0]['mime_type'] : $PODCAST_CATS[$id_cat]['mime_type'];
		
		$Template->assign_vars(array(
			'L_PAGE_TITLE' => $PODCAST_LANG['edit_podcast'],
			'C_CONTRIBUTION' => false,
			'IDEDIT' => $podcast['id'],
			'NAME' => $podcast['name'],
			'CATEGORIES_TREE' => $podcast_cats->build_select_form($podcast['idcat'], 'idcat" onchange="hide_width_height ();', 'idcat', 0, PODCAST_AUTH_WRITE, $PODCAST_CATS[0]['auth'], IGNORE_AND_CONTINUE_BROWSING_IF_A_CATEGORY_DOES_NOT_MATCH),
			'WIDTH' => $podcast['width'],
			'HEIGHT' => $podcast['height'],
			'U_PODCAST' => $podcast['url'],
			'DESCRIPTION' => unparse($podcast['contents']),
			'APPROVED' => $approved,
			'C_APROB' => $c_write AND !$approved,
			'JS_ID_MUSIC' => '"' . implode('", "', $js_id_music) . '"',
			'C_MUSIC' => ($podcast_type == PODCAST_TYPE_MUSIC),
			'ITUNES_FILE_SUBTITLE' => $podcast['itunes_subtitle'],
			'ITUNES_FILE_DURATION' => $podcast['itunes_duration'],
			'ITUNES_FILE_KEYWORDS' => $podcast['itunes_keywords'],
		));
	}
	// Ajout.
	else
	{
		$podcast_cats->bread_crumb($add);

		$Template->assign_vars(array(
			'L_PAGE_TITLE' => $c_write ? $PODCAST_LANG['add_podcast'] : $PODCAST_LANG['contribute_podcast'],
			'C_CONTRIBUTION' => $c_contrib,
			'CONTRIBUTION_COUNTERPART_EDITOR' => display_editor('counterpart'),
			'IDEDIT' => 0,
			'NAME' => '',
			'CATEGORIES_TREE' => $podcast_cats->build_select_form($add, 'idcat" onchange="hide_width_height ();', 'idcat', 0, ($c_write ? PODCAST_AUTH_WRITE : PODCAST_AUTH_CONTRIBUTION), $PODCAST_CATS[0]['auth'], IGNORE_AND_CONTINUE_BROWSING_IF_A_CATEGORY_DOES_NOT_MATCH),
			'WIDTH' => '',
			'HEIGHT' => '',
			'U_PODCAST' => 'http://',
			'DESCRIPTION' => '',
			'APPROVED' => '',
			'C_APROB' => false,
			'JS_ID_MUSIC' => '"' . implode('", "', $js_id_music) . '"',
			'C_MUSIC' => true,
		));
	}

	if (!empty($podcast))
	{
		$Bread_crumb->add($podcast['name'], $podcast_cats->get_item_link($edit,$podcast['idcat'],$podcast['name']));
		$Bread_crumb->add($PODCAST_LANG['edit_podcast'], $podcast_cats->get_action_link(array('edit'=>$podcast['id'])));
		define('TITLE', $PODCAST_LANG['edit_podcast']);
	}
	else
	{
		$Bread_crumb->add($PODCAST_LANG['add_podcast'], url('podcast_action.php'));
		define('TITLE', $PODCAST_LANG['add_podcast']);
	}

	require_once(PATH_TO_ROOT.'/kernel/header.php');
}
// Traitement du formulaire.
elseif (!empty($_POST['submit']))
{
	$Session->csrf_post_protect();

	$idcat = retrieve(POST, 'idcat', 0, TINTEGER);
	$auth = !empty($PODCAST_CATS[$idcat]['auth']) ? $PODCAST_CATS[$idcat]['auth'] : $PODCAST_CATS[0]['auth'];
	
	$c_write = $User->check_auth($auth, PODCAST_AUTH_WRITE);
	$c_contrib = ($User->check_auth($auth, PODCAST_AUTH_CONTRIBUTION) AND !$User->check_level(ADMIN_LEVEL));
	
	if (!$c_write AND !$c_contrib)
	{
		$Errorh->handler('e_auth', E_USER_REDIRECT);
		exit;
	}

	$podcast = array(
		'idedit' => retrieve(POST, 'idedit', 0, TINTEGER),
		'name' => retrieve(POST, 'name', '', TSTRING_UNCHANGE),
		'idcat' => $idcat,
		'width' => min(retrieve(POST, 'width', $PODCAST_CONFIG['width'], TINTEGER), $PODCAST_CONFIG['width']),
		'height' => min(retrieve(POST, 'height', $PODCAST_CONFIG['height'], TINTEGER), $PODCAST_CONFIG['height']),
		'url' => retrieve(POST, 'u_podcast', '', TSTRING_UNCHANGE),
		'contents' => retrieve(POST, 'contents', '', TSTRING_UNCHANGE),
		'approved' => retrieve(POST, 'approved', 0, TBOOL),
		'contrib' => retrieve(POST, 'contrib', 0, TBOOL),
		'counterpart' => retrieve(POST, 'counterpart', '', TSTRING_UNCHANGE),
		'itunes_subtitle' => retrieve(POST, 'itunes_subtitle', '', TSTRING_UNCHANGE),
		'itunes_duration' => retrieve(POST, 'itunes_duration', '', TSTRING_UNCHANGE),
		'itunes_keywords' => retrieve(POST, 'itunes_keywords', '', TSTRING_UNCHANGE),
	);

	$podcast['idcat'] = !empty($PODCAST_CATS[$podcast['idcat']]) ? $podcast['idcat'] : 0;

	$podcast_cats->bread_crumb($podcast['idcat']);

	if ($podcast['idedit'])
	{
		$Bread_crumb->add($podcast['name'], $podcast_cats->get_item_link($podcast['idedit'],$podcast['idcat'],$podcast['name']));
		$Bread_crumb->add($PODCAST_LANG['edit_podcast'], $podcast_cats->get_action_link(array('edit'=>$podcast['idedit'])));
		define('TITLE', $PODCAST_LANG['edit_podcast']);
	}
	else
	{
		$Bread_crumb->add($PODCAST_LANG['add_podcast'], $podcast_cats->get_action_link(array('cat'=>$podcast['idedit'],'add'=>1)));
		define('TITLE', $PODCAST_LANG['add_podcast']);
	}

	require_once(PATH_TO_ROOT.'/kernel/header.php');

	if (!empty($podcast['url']))
	{
		if ($PODCAST_CATS[$podcast['idcat']]['mime_type'] == PODCAST_TYPE_MUSIC)
		{
			$mime_type = $mime_type['audio'];
			$host_ok = $host_ok['audio'];
		}
		elseif ($PODCAST_CATS[$podcast['idcat']]['mime_type'] == PODCAST_TYPE_VIDEO)
		{
			$mime_type = $mime_type['video'];
			$host_ok = $host_ok['video'];
		}
		else
		{
			$mime_type = array_merge($mime_type['audio'], $mime_type['video']);
			$host_ok = array_merge($host_ok['audio'], $host_ok['video']);
		}

		$url_podcast = $podcast['url'];
		$data = explode('?',$url_podcast);
		if ($data !== false)
			$url_podcast = $data[0];

		$url=parse_url($url_podcast,PHP_URL_PATH);
		if (!empty($url) AND ($pathinfo = pathinfo($url)) AND !empty($pathinfo['extension']))
		{
			if (array_key_exists($pathinfo['extension'], $mime_type))
			{
				$podcast['mime_type'] = $mime_type[$pathinfo['extension']];
			}
			else
			{
				$Errorh->handler('e_mime_disable_podcast', E_USER_REDIRECT);
				exit;
			}
		}
		elseif (function_exists('get_headers') AND ($headers = get_headers($podcast['url'], 1)) AND !empty($headers['Content-Type']))
		{
			$h_type = $headers['Content-Type'];
			if (!is_array($h_type) AND in_array($h_type, $mime_type))
			{
				$podcast['mime_type'] = $h_type;
			}
			elseif (is_array($h_type))
			{
				foreach ($h_type as $type)
				{
					if (in_array($type, $mime_type))
					{
						$podcast['mime_type'] = $type;
					}
				}

				if (empty($podcast['mime_type']))
				{
					$Errorh->handler('e_mime_disable_podcast', E_USER_REDIRECT);
					exit;
				}
			}
			else
			{
				$Errorh->handler('e_mime_disable_podcast', E_USER_REDIRECT);
				exit;
			}
		}
		else
		{
			$Errorh->handler('podcast_unknow_mime', E_USER_REDIRECT);
			exit;
		}
	}
	else
	{
		$Errorh->handler('podcast_empty_link', E_USER_REDIRECT);
		exit;
	}
	
	$infos = $User->check_auth($auth, PODCAST_AUTH_WRITE)
		? PODCAST_STATUS_APROBED
		: PODCAST_STATUS_UNAPROBED;

	// dition
	if ($podcast['idedit'] AND $c_write)
	{
		$Sql->query_inject("UPDATE " . PREFIX . "podcast
            SET idcat = " . intval($podcast['idcat']) . ",
                name = '" . $Sql->escape($podcast['name']) . "',
                url= '" . $Sql->escape($podcast['url']) . "',
                mime_type = '". $Sql->escape($podcast['mime_type'])."',
                contents = '" . $Sql->escape(strparse($podcast['contents'],array(),false)) . "',
                infos = " . intval($infos) . ",
                width = " . intval($podcast['width']) . ",
                height = " . intval($podcast['height']) . ",
				itunes_subtitle = '".$Sql->escape($podcast['itunes_subtitle'])."',
				itunes_duration = '".$Sql->escape($podcast['itunes_duration'])."',
				itunes_keywords = '".$Sql->escape($podcast['itunes_keywords'])."'
                WHERE id = " . intval($podcast['idedit']) . "
                LIMIT 1", __LINE__, __FILE__);

		$podcast_cats->recount_podcast_per_cat($podcast['idcat']);

		if ($podcast['approved'] AND $c_write)
		{
			import('events/contribution');
			import('events/contribution_service');

			$contributions = ContributionService::find_by_criteria('podcast', $podcast['idedit']);

			if (count($contributions) > 0)
			{
				$contribution = $contributions[0];
				$contribution->set_status(EVENT_STATUS_PROCESSED);
				ContributionService::save_contribution($contribution);
			}
		}

		// Feeds Regeneration
		import('content/syndication/feed');
		Feed::clear_cache('podcast');

		require_once('podcast_xml.class.php');
        $xml = new PodcastXml();
        $xml->render($podcast['idcat']);
		unset($xml);

		redirect_confirm($podcast_cats->get_cat_short_link($podcast['idcat']), $PODCAST_LANG['edit_success'], TIME_REDIRECT);
	}
	// Ajout
	elseif (!$podcast['idedit'])
	{
		$Sql->query_inject("INSERT INTO " . PREFIX . "podcast
            SET iduser = ".$User->Get_attribute('user_id').",
                timestamp = ".time().",
				idcat = " . intval($podcast['idcat']) . ",
                name = '".$Sql->escape($podcast['name'])."',
                contents = '".$Sql->escape(strparse($podcast['contents'],array(),false))."',
                url = '".$Sql->escape($podcast['url'])."',
                mime_type = ".intval($podcast['mime_type']).",
                infos = ".intval($infos).",
                width = ".intval($podcast['width']).",
                height = ".intval($podcast['height']).",
				itunes_subtitle = '".$Sql->escape($podcast['itunes_subtitle'])."',
				itunes_duration = '".$Sql->escape($podcast['itunes_duration'])."',
				itunes_keywords = '".$Sql->escape($podcast['itunes_keywords'])."',
                users_note = ''", __LINE__, __FILE__);

		$new_id_podcast = $Sql->insert_id('');
		$podcast_cats->recount_podcast_per_cat($podcast['idcat']);
		// Feeds Regeneration
		import('content/syndication/feed');
		Feed::clear_cache('podcast');

		if ($c_contrib)
		{
			import('events/contribution');
			import('events/contribution_service');

			$contribution = new Contribution();
			$contribution->set_id_in_module($new_id_podcast);
			$contribution->set_description($podcast['counterpart']);
			$contribution->set_entitled(sprintf($PODCAST_LANG['contribution_entitled'], $podcast['name']));
			$contribution->set_fixing_url($podcast_cats->get_action_link(array('edit'=>$new_id_podcast)));
			$contribution->set_poster_id($User->get_attribute('user_id'));
			$contribution->set_module('podcast');
			$contribution->set_auth(Authorizations::capture_and_shift_bit_auth(Authorizations::merge_auth($PODCAST_CATS[0]['auth'], $podcast_cats->compute_heritated_auth($podcast['idcat'], PODCAST_AUTH_WRITE, AUTH_CHILD_PRIORITY), PODCAST_AUTH_WRITE, AUTH_CHILD_PRIORITY), PODCAST_AUTH_WRITE, CONTRIBUTION_AUTH_BIT));

			ContributionService::save_contribution($contribution);

			redirect($podcast_cats->get_action_link(array('cat'=>$podcast['idcat']),false,'contribution'));
		}
		
		require_once('podcast_xml.class.php');		
		$xml = new PodcastXml();
		$xml->render($podcast['idcat']);
		unset($xml);

		redirect_confirm($podcast_cats->get_cat_short_link($podcast['idcat']), $PODCAST_LANG['add_success'], TIME_REDIRECT);
		exit;
	}
	else
	{
		$Errorh->handler('e_auth', E_USER_REDIRECT);
		exit;
	}
}
else
{
	$Errorh->handler('e_auth', E_USER_REDIRECT);
	exit;
}

$Template->pparse('podcast_action');

require_once(PATH_TO_ROOT.'/kernel/footer.php');

?>