<?php
/*##################################################
 *
 *   $Id: podcast_constant.php 418 2012-03-07 20:12:14Z alain_dev $
 *
 *   begin               	: January 15, 2012
 *   copyright        	    : (C) 2012 Alain GANDON
 *   email               	: alain091@gmail.com
 *
 *   fork from podcast module
 *
###################################################
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
###################################################*/

defined('PHPBOOST') OR exit;

// Permissions des catgories.
define('PODCAST_AUTH_READ', 1);
define('PODCAST_AUTH_CONTRIBUTION', 2);
define('PODCAST_AUTH_WRITE', 4);

// Information mime type.
define('PODCAST_TYPE_BOTH', 0);
define('PODCAST_TYPE_MUSIC', 1);
define('PODCAST_TYPE_VIDEO', 2);

// Informations sur les fichiers.
define('PODCAST_STATUS_UNAPROBED', 0);
define('PODCAST_STATUS_UNVISIBLE', 1);
define('PODCAST_STATUS_APROBED', 2);

// Paramtres d'affichage.
define('PODCAST_COM', 1);    	// Affiche les commentaires.
define('PODCAST_NOTE', 2);   	// Affiche les notes.
define('PODCAST_USER', 4);		// Affiche le nom du posteur.
define('PODCAST_COUNT', 8); 	// Affiche le compteur.
define('PODCAST_DATE', 16);  	// Affiche la date de cration
define('PODCAST_DESC', 32); 	// Affiche la description
define('PODCAST_NBR', 64);		// Affiche le nombre

defined('TIME_REDIRECT') or define('TIME_REDIRECT', 5);		// Paramtre de redirection en seconde.

define('NUM_MODO_PODCAST', 25);	// Nombre de fichiers par page dans le panneau de modration.

// Type de fichier autoriss.
$mime_type = array(
	'audio' => array(
		'mp3' => 'audio/mp3',
	),
	'video' => array(
		'flv' => 'video/x-flv',
		'swf' => 'application/x-shockwave-flash'
	)
);

// Fichier en fonction du mime type.
$mime_type_tpl = array(
	'video/x-flv' => 'format/podcast_flv.tpl',
	'application/x-shockwave-flash' => 'format/podcast_swf.tpl',
	'audio/mpeg' => 'format/podcast_mp3.tpl'
);

// Host de confiance!
$host_ok = array(
	'video' => array(
		'www.dailymotion.com',
		'www.youtube.com',
		'video.google.fr',
		'www.wat.tv'
	),
	'audio' => array(
		'www.deezer.com',
		'widgets.jamendo.com'
	)
);

$podcast_httprequest_config = array(
	'xmlhttprequest_file' => 'xmlhttprequest_cats.php',
	'administration_file_name' => 'admin_podcast_cats.php',
	'url' => array(
		'unrewrited' => 'podcast.php?id=%d',
		'rewrited' => 'podcast-%d+%s.php'
	)
);

$podcast_httprequest_2_config = array(
	'xmlhttprequest_file' => 'xmlhttprequest_cats.php',
	'administration_file_name' => 'admin_podcast_cats.php',
	'url' => array(
		'unrewrited' => 'podcast.php?id=%d&cat=%d',
		'rewrited' => 'podcast-%d-%d+%s.php'
	)
);

$podcast_httprequest_cat_config = array(
    'xmlhttprequest_file' => 'xmlhttprequest_cats.php',
    'administration_file_name' => 'admin_podcast_cats.php',
	'url' => array(
		'unrewrited' => 'podcast.php?cat=%d',
		'rewrited' => 'podcast-0-%d+%s.php'
	)
);

?>