<?php
/*##################################################
 *
 *   $Id: podcast_interface.class.php 418 2012-03-07 20:12:14Z alain_dev $
 *
 *   begin               	: January 15, 2012
 *   copyright        	    : (C) 2012 Alain GANDON
 *   email               	: alain091@gmail.com
 *
 *   fork from podcast module
 *
###################################################
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
###################################################*/

defined('PHPBOOST') OR exit;

import('modules/module_interface');

define('PODCAST_MAX_SEARCH_RESULTS', 100);

// Classe ForumInterface qui hrite de la classe ModuleInterface
class PodcastInterface extends ModuleInterface
{
    ## Public Methods ##
    function PodcastInterface() //Constructeur de la classe ForumInterface
    {
        parent::ModuleInterface('podcast');
    }

	//Rcupration du cache.
	function get_cache()
	{
		global $Sql;

		require_once PATH_TO_ROOT . '/podcast/podcast_constant.php';

		//Configuration
		$config = array();
		$result = $Sql->query("SELECT value
            FROM " . DB_TABLE_CONFIGS . "
            WHERE name = 'podcast'
            LIMIT 1", __LINE__, __FILE__);
		if (!empty($result))
		{
			$config = unserialize($result);
			if (!empty($config))
			{
				$root_config = $config['root'];
				unset($config['root']);
			}
		}
		if (empty($config))
		{
			$config = array(
				'pagin'=>25,
				'nbr_column'=>2,
				'note_max'=>5,
				'width'=>900,
				'height'=>600,
				);

			$root_config=array(
				'id_parent'=>-1,
				'order'=>1,
				'name'=>'Podcast',
				'desc'=>'Voici le module Podcast pour PHPboost 3.0',
				'visible'=>true,
				'image'=>'podcast.png',
				'num_podcast'=>0,
				'mime_type'=>0,
				'active'=>0,
				'itunes_copyright' => 'Mettre ici un copyright',
				'itunes_author' => 'Mettre ici un auteur',
				'itunes_email' => 'Mettre ici un email',
				'auth'=>array(
					'r-1'=>1,
					'r0'=>3,
					'r1'=>7,
					),
				);

			$tmp = $config;
			$tmp['root'] = $root_config;
			$stmp = serialize($tmp);
			$result = $Sql->query("UPDATE " . DB_TABLE_CONFIGS . "
				SET
					value = '".$Sql->escape($stmp)."'
				WHERE name = 'podcast'
				LIMIT 1", __LINE__, __FILE__);
		}

		$string = 'global $PODCAST_CONFIG, $PODCAST_CATS;' . "\n\n" . '$PODCAST_CONFIG = $PODCAST_CATS = array();' . "\n\n";
		$string .= '$PODCAST_CONFIG = ' . var_export($config, true) . ';' . "\n\n";

		//List of categories and their own properties
		$string .= '$PODCAST_CATS[0] = ' . var_export($root_config, true) . ';' . "\n\n";
		$result = $Sql->query_while("SELECT *
            FROM " . PREFIX . "podcast_cat
            ORDER BY id_parent, c_order ASC", __LINE__, __FILE__);

		while ($row = $Sql->fetch_assoc($result))
		{
			$string .= '$PODCAST_CATS[' . $row['id'] . '] = ' . var_export(array(
				'id_parent' => (int)$row['id_parent'],
				'order' => (int)$row['c_order'],
				'name' => $row['name'],
				'desc' => $row['description'],
				'itunes_subtitle' => $row['itunes_subtitle'],
				'itunes_categories' => $row['itunes_categories'],
				'visible' => (bool)$row['visible'],
				'image' => $row['image'],
				'num_podcast' => (int)$row['num_podcast'],
				'mime_type' => (int)$row['mime_type'],
				'active' => (int)$row['active'],
				'auth' => (array)unserialize($row['auth'])
			), true) . ';' . "\n\n";
		}

		$Sql->query_close($result);

		return $string;
	}

	// Generate the feed data structure used by RSS, ATOM and feed informations on the website
    function get_feed_data_struct($idcat = 0)
    {
    	global $Cache, $Sql, $LANG, $CONFIG, $PODCAST_LANG, $PODCAST_CONFIG, $PODCAST_CATS;

        $Cache->load('podcast');
		load_module_lang('podcast');

        require_once(PATH_TO_ROOT . '/podcast/podcast_constant.php');
		if (!class_exists('PodcastCats'))
			require_once(PATH_TO_ROOT . '/podcast/podcast_cats.class.php');
		import('content/syndication/feed_data');
		import('util/date');
		import('util/url');

        $data = new FeedData();

        // Meta-informations generation
        $data->set_title($PODCAST_LANG['xml_podcast_desc']);
        $data->set_date(new Date());
        $data->set_link(new Url('/syndication.php?m=podcast&amp;cat=' . $idcat));
        $data->set_host(HOST);
        $data->set_desc($PODCAST_LANG['xml_podcast_desc']);
        $data->set_lang($LANG['xml_lang']);
        $data->set_auth_bit(PODCAST_AUTH_READ);

        // Building Categories to look in
        $cats = new PodcastCats();
        $children_cats = array();
        $cats->build_children_id_list($idcat, $children_cats, RECURSIVE_EXPLORATION, ADD_THIS_CATEGORY_IN_LIST);

        $result = $Sql->query_while ("SELECT id, idcat, name, contents, timestamp
			FROM " . PREFIX . "podcast
			WHERE infos = " . intval(PODCAST_STATUS_APROBED) . "
			AND idcat IN (" . implode($children_cats, ','). " )
			ORDER BY timestamp DESC" . $Sql->limit(0, $PODCAST_CONFIG['pagin']), __LINE__, __FILE__);

        // Generation of the feed's items
        while ($row = $Sql->fetch_assoc($result))
        {
            $item = new FeedItem();

            // Rewriting
            $link = new Url('/podcast/podcast' . url(
                '.php?id=' . $row['id'],
                '-' . $row['id'] . '+' . url_encode_rewrite($row['name']) . '.php'
            ));

            // Adding item's informations
            $item->set_title($row['name']);
            $item->set_link($link);
            $item->set_guid($link);
            $item->set_desc(second_parse($row['contents']));
            $item->set_date(new Date(DATE_TIMESTAMP, TIMEZONE_SYSTEM, $row['timestamp']));
            $item->set_image_url($PODCAST_CATS[$row['idcat']]['image']);
            $item->set_auth($cats->compute_heritated_auth($row['idcat'], PODCAST_AUTH_READ, AUTH_PARENT_PRIORITY));

            // Adding the item to the list
            $data->add_item($item);
        }

        $Sql->query_close($result);

        return $data;
    }

    /**
     *  Renvoie la requte de recherche
     */
    function get_search_request($args)
    {
        global $Sql, $Cache;

        $weight = isset($args['weight']) && is_numeric($args['weight']) ? $args['weight'] : 1;

		if (!class_exists('PodcastCats'))
			require_once PATH_TO_ROOT . '/podcast/podcast_cats.class.php';
        $Cats = new PodcastCats();

        $auth_cats = array();
        $Cats->build_children_id_list(0, $auth_cats);

        $auth_cats = !empty($auth_cats) ? " AND f.idcat IN (" . implode($auth_cats, ',') . ") " : '';

        $request = "SELECT " . $args['id_search'] . " AS id_search,
            f.id AS id_content,
            f.name AS title,
            ( 2 * MATCH(f.name) AGAINST('" . $args['search'] . "') + MATCH(f.contents) AGAINST('" . $args['search'] . "') ) / 3 * " . $weight . " AS relevance, "
            . $Sql->concat("'".PATH_TO_ROOT."/podcast/podcast.php?id='","f.id","'&amp;cat='","f.idcat") . " AS link
            FROM " . PREFIX . "podcast f
            WHERE ( MATCH(f.name) AGAINST('" . $args['search'] . "') OR MATCH(f.contents) AGAINST('" . $args['search'] . "') )" . $auth_cats
            . " ORDER BY relevance DESC " . $Sql->limit(0, PODCAST_MAX_SEARCH_RESULTS);

        return $request;
    }

	/**
     * @desc Return the list of the feeds available for this module.
     * @return FeedsList The list
     */
    function get_feeds_list()
	{
		if (!class_exists('PodcastCats'))
			require_once PATH_TO_ROOT . '/podcast/podcast_cats.class.php';
        $podcast_cats = new PodcastCats();
        return $podcast_cats->get_feeds_list();
	}
}

?>
