<?php
/*##################################################
 *
 *   $Id: podcast_xml.class.php 420 2012-03-10 11:26:10Z alain_dev $
 *
 *   begin               	: January 15, 2012
 *   copyright        	    : (C) 2012 Alain GANDON
 *   email               	: alain091@gmail.com
 *
 *   fork from podcast module
 *
###################################################
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
###################################################*/

defined('PHPBOOST') OR exit;

require_once PATH_TO_ROOT . '/podcast/podcast_constant.php';

class PodcastXml
{
    var $template = false;

	//Constructor
	function PodcastXml()
	{
        $this->template = new Template();
        $this->template->set_filenames(array('xmldata'=> 'podcast/xmldata.tpl'));
	}

    function MakeGUID ($str) {
        $h = "-";
        $str = uniqid($str, true);
        $gMd5 = md5($str);
        //$guidTag = substr($gMd5,0,8) . $h . substr($gMd5,7,4) . $h .
        //substr($gMd5,11,4) . $h . substr($gMd5,15,4) . $h . substr($gMd5,19,12);
        $guidTag = $gMd5;
        return $guidTag;
    }


    function extract_categories($str,&$data)
    {
        $t1 = explode(';',$str);
        foreach($t1 as $t)
        {
            $x1 = explode('>',$t);
            $first = array_shift($x1);
            if (!empty($x1))
                $data[$first] = array_shift($x1);
            else
                $data[$first] = false;
        }
    }

	protected function my_encode($str)
	{
		$tmp = $str;
		$tmp = utf8_encode($str);
		$tmp = preg_replace('#&(?!amp;)#', '&amp;', $tmp);
		$tmp = preg_replace('#[>]#', '&gt;', $tmp);
		$tmp = preg_replace('#[<]#', '&lt;', $tmp);
		$tmp = preg_replace('#[\']#', '&apos;', $tmp);
		$tmp = preg_replace('#[\"]#', '&aquot;', $tmp);
		return $tmp;
	}

    function render($id_cat)
    {
        global $Sql, $CONFIG, $PODCAST_CATS;
		
		$id_cat = intval($id_cat);
		if (empty($id_cat)) return false;

        $podcast_cache_cat =& $PODCAST_CATS[$id_cat];

        if (!class_exists('PodcastCats'))
            require_once('podcast_cats.class.php');

        $podcast_categories = new PodcastCats();

        $title = $podcast_cache_cat['name'];

        $link = $podcast_categories->get_cat_link($id_cat, $title);
        $link = HOST.DIR.'/podcast/'.$link;
        $image = $podcast_cache_cat['image'];
        $image = HOST.DIR.'/podcast/'.$image;

        switch($CONFIG['lang'])
        {
            default:
            case 'french':
                $language = 'fr';
                break;
            case 'english':
                $language = 'en';
                break;
        }

        $author = $PODCAST_CATS[0]['itunes_author'];
        $copyright = $PODCAST_CATS[0]['itunes_copyright'];
        $itunes_email = $PODCAST_CATS[0]['itunes_email'];
        $itunes_author = $author;

        $itunes_subtitle = $podcast_cache_cat['itunes_subtitle'];
        $itunes_summary = $podcast_cache_cat['desc'];

        $this->template->assign_vars(array(
			'XML_TITLE' => $this->my_encode($title),
			'XML_LINK' => $link,
			'XML_LANGUAGE' => $language,
			'XML_COPYRIGHT' => $this->my_encode($copyright),
			'XML_ITUNES_SUBTITLE' => $this->my_encode($itunes_subtitle),
			'XML_ITUNES_AUTHOR' => $this->my_encode($itunes_author),
			'XML_ITUNES_SUMMARY' => $this->my_encode($itunes_summary),
			'XML_ITUNES_NAME' => $this->my_encode($itunes_author),
			'XML_ITUNES_EMAIL' => $this->my_encode($itunes_email),
			'XML_ITUNES_IMAGE' => $image,
            ));

        $tmp = $podcast_cache_cat['itunes_categories'];
        $data = array();
        $this->extract_categories($tmp, $data);
        foreach($data as $key => $value)
        {
            $this->template->assign_block_vars('categories', array(
                'C_TREE' => !empty($value),
                'VALUE' => $this->my_encode($key),
                'CHILD' => $this->my_encode($value),
                ));
        }

        $result = $podcast_categories->get_all_cats($id_cat);
		while ($row = $Sql->fetch_assoc($result))
        {
            $summary = $row['contents'];
            $url = $row['url'];
			if (strpos($url,'http:') !== false)
			{
				$uri = $url;
				$header = get_headers($uri,true);
				$found = strpos($header[0],'200'); // 200 OK
				if ($header == false OR $found === false)
					$fsize = 0;
				else
					$fsize = intval($header['Content-Length']);
			}
			else
			{
				$uri = HOST.DIR.'/'.$url;
				$file = $_SERVER['DOCUMENT_ROOT'].DIR.'/'.$url;
				if (file_exists($file))
					$fsize = filesize($file);
				else
					$fsize = 0;
			}
			
            $pubdate = date("r", $row['timestamp']);
            $this->template->assign_block_vars('item', array(
				'XML_TITLE' => $this->my_encode($row['name']),
				'XML_ITUNES_AUTHOR' => $this->my_encode($author),
				'XML_ITUNES_SUBTITLE' => $this->my_encode($row['itunes_subtitle']),
				'XML_ITUNES_SUMMARY' => $this->my_encode($summary),
				'XML_ITUNES_IMAGE' => $image,
				'XML_ENCLOSURE_URL' => $uri,
				'XML_ENCLOSURE_LENGTH' => intval($fsize),
				'XML_ENCLOSURE_TYPE' => $row['mime_type'],
				'XML_GUID' => $this->makeGUID($url),
				'XML_PUBDATE' => $pubdate,
				'XML_ITUNES_DURATION' => $this->my_encode($row['itunes_duration']),
				'XML_ITUNES_KEYWORDS' => $this->my_encode($row['itunes_keywords']),
                ));
        }

        $tmp = $this->template->pparse('xmldata', true);

        file_put_contents('xml/'.url_encode_rewrite($title).'.xml', $tmp);
    }
}

?>