<?php
/*##################################################
 *
 *   $Id: xmlhttprequest_cats.php 389 2012-02-11 20:41:36Z alain_dev $
 *
 *   begin               	: January 15, 2012
 *   copyright        	    : (C) 2012 Alain GANDON
 *   email               	: alain091@gmail.com
 *
 *   fork from podcast module
 *
###################################################
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
###################################################*/

defined('PATH_TO_ROOT') OR define('PATH_TO_ROOT','..');

define('NO_SESSION_LOCATION', true);

require_once(PATH_TO_ROOT.'/kernel/begin.php');
require_once('podcast_constant.php');
require_once(PATH_TO_ROOT.'/kernel/header_no_display.php');

if ($User->check_level(ADMIN_LEVEL))
{
	require_once('podcast_cats.class.php');
	$podcast_categories = new PodcastCats();
	
	$id_up = retrieve(GET, 'id_up', 0, TINTEGER);
	$id_down = retrieve(GET, 'id_down', 0, TINTEGER);
	$id_show = retrieve(GET, 'show', 0, TINTEGER);
	$id_hide = retrieve(GET, 'hide', 0, TINTEGER);
	$cat_to_del = retrieve(GET, 'del', 0, TINTEGER);
	
	$result = false;

	if ($id_up > 0)
	{
		$result = $podcast_categories->move($id_up, MOVE_CATEGORY_UP);
	}
	elseif ($id_down > 0)
	{
		$result = $podcast_categories->move($id_down, MOVE_CATEGORY_DOWN);
	}
	elseif ($id_show > 0)
	{
		$result = $podcast_categories->change_visibility($id_show, CAT_VISIBLE, LOAD_CACHE);
	}
	elseif ($id_hide > 0)
	{
		$result = $podcast_categories->change_visibility($id_hide, CAT_UNVISIBLE, LOAD_CACHE);
	}

	//Operation was successfully
	if ($result)
	{
		$podcast_categories->set_display_config($podcast_httprequest_cat_config);
		$Cache->load('podcast', RELOAD_CACHE);
		echo $podcast_categories->build_administration_interface(AJAX_MODE);
	}
}

require_once(PATH_TO_ROOT.'/kernel/footer_no_display.php');
